clear all; close all; rand('seed',0);

tbmean = [18, 21, 24]; tbdev = [1.5, 1.5, 1.5];
tkmean = [5, 20, 35]; tkdev = [6, 6, 6];
amean = [0, 30, 50, 100]; adev = [10, 10, 20, 30];
tbmax = length(tbmean);
tkmax = length(tkmean);
amax = length(amean);
N = 500;   % adatpontok szama
datav = zeros(3,N);

% Tudas bazis,  ij = 1,2,3 tk, tb fuzzy halmaz indexek, tartalom a fh index
TBN=9;
TB = [3, 1, 1;
      2, 1, 1;
      1, 1, 1;
      1, 2, 4;
      1, 3, 4;
      2, 3, 4;
      3, 3, 4;
      2, 2, 4;
      3, 2, 4];
  
k=1;
while k<N+1,
    irule = fix(TBN*rand+1); 
    i = TB(irule,1); j = TB(irule,2);
           if i==1, v1 = rndgen('L',tbmean(i),tbdev(i));
           elseif i==tbmax, v1 = rndgen('R',tbmean(i),tbdev(i));
           else v1 = rndgen('M',tbmean(i),tbdev(i)); end;
           if j==1, v2 = rndgen('L',tkmean(j),tkdev(j));
           elseif j==tkmax, v2 = rndgen('R',tkmean(j),tkdev(j));
           else v2 = rndgen('M',tkmean(j),tkdev(j)); end;
           v3index = TB(irule,3);
           if v3index==1, v3 = rndgen('L',amean(v3index),adev(v3index));
           elseif v3index==amax, v3 = rndgen('R',amean(v3index),adev(v3index));
           else v3 = rndgen('M',amean(v3index),adev(v3index)); end;
           
           if (tbmean(1)<=v1)&(v1<=tbmean(tbmax)), 
               if (tkmean(1)<=v2)&(v2<=tkmean(tkmax)), 
                   if (amean(1)<=v3)&(v3<=amean(amax)), 
                       datav(:,k) = [v1, v2, v3]; k = k+1, end; end; end;
end;

figure(1), subplot(3,1,1), plot(datav(1,:)); title('Belso'); grid;
subplot(3,1,2), plot(datav(2,:)); title('Kulso'); grid;
subplot(3,1,3), plot(datav(3,:)); title('Ablak'); grid;

save birlabdata;

datav = zeros(3,N);

TBN=9;
TBtest1 = [3, 1, 1;
      2, 1, 1;
      1, 1, 1;
      1, 2, 4;
      1, 3, 4;
      2, 3, 4;
      3, 3, 4;
      2, 2, 4;
      3, 2, 4];

N1=N/2;

k=1;
while k<N1+1,
    irule = fix(TBN*rand+1); 
    i = TBtest1(irule,1); j = TBtest1(irule,2);
           if i==1, v1 = rndgen('L',tbmean(i),tbdev(i));
           elseif i==tbmax, v1 = rndgen('R',tbmean(i),tbdev(i));
           else v1 = rndgen('M',tbmean(i),tbdev(i)); end;
           if j==1, v2 = rndgen('L',tkmean(j),tkdev(j));
           elseif j==tkmax, v2 = rndgen('R',tkmean(j),tkdev(j));
           else v2 = rndgen('M',tkmean(j),tkdev(j)); end;
           v3index = TBtest1(irule,3);
           if v3index==1, v3 = rndgen('L',amean(v3index),adev(v3index));
           elseif v3index==amax, v3 = rndgen('R',amean(v3index),adev(v3index));
           else v3 = rndgen('M',amean(v3index),adev(v3index)); end;
           
           if (tbmean(1)<=v1)&(v1<=tbmean(tbmax)), 
               if (tkmean(1)<=v2)&(v2<=tkmean(tkmax)), 
                   if (amean(1)<=v3)&(v3<=amean(amax)), 
                       datav(:,k) = [v1, v2, v3]; k = k+1, end; end; end;
end;


TBN=9;
TBtest2 = [3, 1, 1;
      2, 1, 1;
      1, 1, 1;
      1, 2, 2;
      1, 3, 2;
      2, 3, 2;
      3, 3, 2;
      2, 2, 2;
      3, 2, 2];

k=N1+1;
while k<N+1,
    irule = fix(TBN*rand+1); 
    i = TBtest2(irule,1); j = TBtest2(irule,2);
           if i==1, v1 = rndgen('L',tbmean(i),tbdev(i));
           elseif i==tbmax, v1 = rndgen('R',tbmean(i),tbdev(i));
           else v1 = rndgen('M',tbmean(i),tbdev(i)); end;
           if j==1, v2 = rndgen('L',tkmean(j),tkdev(j));
           elseif j==tkmax, v2 = rndgen('R',tkmean(j),tkdev(j));
           else v2 = rndgen('M',tkmean(j),tkdev(j)); end;
           v3index = TBtest2(irule,3);
           if v3index==1, v3 = rndgen('L',amean(v3index),adev(v3index));
           elseif v3index==amax, v3 = rndgen('R',amean(v3index),adev(v3index));
           else v3 = rndgen('M',amean(v3index),adev(v3index)); end;
           
           if (tbmean(1)<=v1)&(v1<=tbmean(tbmax)), 
               if (tkmean(1)<=v2)&(v2<=tkmean(tkmax)), 
                   if (amean(1)<=v3)&(v3<=amean(amax)), 
                       datav(:,k) = [v1, v2, v3]; k = k+1, end; end; end;
end;

figure(2), subplot(3,1,1), plot(datav(1,:)); title('Belso'); grid;
subplot(3,1,2), plot(datav(2,:)); title('Kulso'); grid;
subplot(3,1,3), plot(datav(3,:)); title('Ablak'); grid;

save birlabtest;



