function y = mebextfms(N,nofinput,ithfs,xdatapoint,fmfsets)

% 
% nofinput    	- bemeneti univerzum indexe, ill. a kimeneti univerzum indexe 
%                   (bemenetek szama + 1)
% N             - fuzzy halmazok szama egy univerzum felett
% ithfs       	- fuzzy halmaz indexe (meresnel 1..3 bemenet, 1..4 kimenet)
% xdatapoint  	- mert adat
% fmfsets     	- fuzzy halmaz leiro, ld. kesobb
%
%  a11, b11, c11, d11
%  a12, b12, c12, d12
%    ...
%  a1N, b1N, c1N, d1N    - N db trapez tagsagi fuggveny az 1. bemenethez                                                         
%  a21, b21, c21, d21
%  a22, b22, c22, d22
%    ...
%  a2N, b2N, c2N, d2N    - N db trapez tagsagi fuggveny a 2. bemenethez
%	stb. stb.
%  a11, b11, c11, d11
%  a12, b12, c12, d12
%    ...
%  a1N1, b1N1, c1N1, d1N1 - N1 db trapez tagsagi fuggveny a kimenethez
%                       (meresnel tipikusan N=3, N1=2 lesz)                                                         

aindex=(nofinput-1)*N+ithfs;
a=fmfsets(aindex,1);
b=fmfsets(aindex,2);
c=fmfsets(aindex,3);
d=fmfsets(aindex,4);

if xdatapoint<a, y=0; 
elseif xdatapoint<b, y=(xdatapoint-a)/(b-a);
elseif xdatapoint<c, y=1;
elseif xdatapoint<d, y=(d-xdatapoint)/(d-c);
else y=0; end; 
 