% 1. Feladat: Kiserletezes fuzzy klaszterezessel

% 1D (egy darab bemeneti univerzum) adatok klaszterezese, 
% kulonbozo kiserletek, irodalom: Clustering - Fuzzy C-means.mht

NC2=3;                      % klaszterszam hatasa
Exponent=1.2;               % kitevo hatasa, pl. 1 - teglalap, 
                            % 1.2 - kb. trapez, 1.5 - kb. Gauss
% fuzzy klaszterezes hivasa

[centers,U,obj_fcn] = fcm(data2,NC2,Exponent);   
                            % centers - a klaszterek kozeppontja
                            % U a klaszterpontok sulya
                            
figure(5), plot(data2,U,'o'); grid; 
title('Fuzzy klaszterek'); xlabel('osszes adat');
 
% klaszter sulyok elkulonitese klaszterenkent
% egy bemeneti pont tenyleges klasztere, amely a tobbinel nagyobb 
% sulyt rendel a bemeneti ponthoz

maxU = max(U);                      % adat klasztere, ra nezve max tagsagu
index1 = find(U(1,:) == maxU);      % adatok, tagsaga klaszter 1-ben max
index2 = find(U(2,:) == maxU);      % adatok, tagsaga klaszter 2-ben max
index3 = find(U(3,:) == maxU);      % adatok, tagsaga klaszter 3-ben max
 
figure(6), subplot(3,1,1), plot(data2(index1),U(1,index1),'og'); 
grid; title('Fuzzy klaszter 1, sajat adatai felett'); 
xlabel('klaszeter 1 adatai');
figure(6), subplot(3,1,2), plot(data2(index2),U(2,index2),'ob'); 
grid; title('Fuzzy klaszter 2, sajat adatai felett'); 
xlabel('klaszter 2 adatai');
figure(6), subplot(3,1,3), plot(data2(index3),U(3,index3),'or'); 
grid; title('Fuzzy klaszter 3, sajat adatai felett'); 
xlabel('klaszter 3 adatai');
 
xdata2=data2'; ydata21=U(1,:); ydata22=U(2,:); ydata23=U(3,:); % atnevezes
 
figure(7), subplot(3,1,1), plot(xdata2, ydata21,'og'); 
grid; title('Fuzzy klaszter 1 sulyfuggvenye'); 
xlabel('osszes adaterjedelem');
figure(7), subplot(3,1,2), plot(xdata2, ydata22,'ob'); 
grid; title('Fuzzy klaszter 2 sulyfuggvenye'); 
xlabel('osszes adaterjedelem');
figure(7), subplot(3,1,3), plot(xdata2, ydata23,'or'); 
grid; title('Fuzzy klaszter 3 sulyfuggvenye'); 
xlabel('osszes adaterjedelem');

