% 1. Feladat: Kiserletezes fuzzy klaszterezessel

% 1D (egy darab kimeneti univerzum) adatok klaszterezese, 

CN=4;               % klaszterszam hatasa
ExN=1.2;            % kitevo hatasa, 1 - szogletes, 
                    % 1.2 - kb. trapez, 1.5 - kb. Gauss
 
[centery,Uy,obj_fcn] = fcm(datay,CN,ExN);    
                    % centery - a kimeneti klaszterek kozeppontja
                    % U a klaszterpontok sulya
                    
figure(1), plot(datay,Uy,'o'); grid;
title('Kimeneti fuzzy klaszterek'); xlabel('osszes adat');
%

maxUy = max(Uy);                    % egy adathoz tartozo klaszter
                                    % a ra nezve max tagsagu
index1y = find(Uy(1,:) == maxUy);   % kimeneti adatok, tagsaga klaszter 1-ben max
index2y = find(Uy(2,:) == maxUy);   % kimeneti adatok, tagsaga klaszter 2-ben max
index3y = find(Uy(3,:) == maxUy);   % kimeneti adatok, tagsaga klaszter 3-ben max
index4y = find(Uy(4,:) == maxUy);   % kimeneti adatok, tagsaga klaszter 4-ben max
 
figure(9), subplot(4,1,1), plot(datay(index1y),Uy(1,index1y),'og'); 
grid; title('Kimeneti fuzzy klaszter 1, sajat adatai felett'); 
xlabel('kimeneti klaszeter 1 adatai');
figure(9), subplot(4,1,2), plot(datay(index2y),Uy(2,index2y),'ob'); 
grid; title('Kimeneti fuzzy klaszter 2, sajat adatai felett'); 
xlabel('kimeneti klaszeter 2 adatai');
figure(9), subplot(4,1,3), plot(datay(index3y),Uy(3,index3y),'ob'); 
grid; title('Kimeneti fuzzy klaszter 3, sajat adatai felett'); 
xlabel('kimeneti klaszeter 3 adatai');
figure(9), subplot(4,1,4), plot(datay(index4y),Uy(4,index4y),'ob'); 
grid; title('Kimeneti fuzzy klaszter 4, sajat adatai felett'); 
xlabel('kimeneti klaszeter 4 adatai');
 
xdatay=datay'; ydata1y=Uy(1,:); ydata2y=Uy(2,:);    % atnevezes
ydata3y=Uy(3,:); ydata4y=Uy(4,:);

figure(11), subplot(4,1,1), plot(xdatay, ydata1y,'o'); 
grid; title('Kimeneti fuzzy klaszter 1 sulyfuggvenye'); 
xlabel('osszes adaterjedelem');
figure(11), subplot(4,1,2), plot(xdatay, ydata2y,'o'); 
grid; title('Kimeneti fuzzy klaszter 2 sulyfuggvenye'); 
xlabel('osszes adaterjedelem');
figure(11), subplot(4,1,3), plot(xdatay, ydata3y,'o'); 
grid; title('Kimeneti fuzzy klaszter 3 sulyfuggvenye'); 
xlabel('osszes adaterjedelem');
figure(11), subplot(4,1,4), plot(xdatay, ydata4y,'o'); 
grid; title('Kimeneti fuzzy klaszter 4 sulyfuggvenye'); 
xlabel('osszes adaterjedelem');


