% 2. Feladat: Fuzzy tagsagi fuggvenyek kialaktasa fuzzy klaszterekbol

% a klaszter ponthalmazok kozepertek es variancia adatai 
% LSE parameteres approximaciohoz
xmean11=sum(xdata1.*ydata11)/sum(ydata11);
xstd11=sum(((xdata1-xmean11).^2).*ydata11)/sum(ydata11);     % 1 klaszter
xmean12=sum(xdata1.*ydata12)/sum(ydata12);
xstd12=sum(((xdata1-xmean12).^2).*ydata12)/sum(ydata12);     % 2 klaszter
xmean13=sum(xdata1.*ydata13)/sum(ydata13);
xstd13=sum(((xdata1-xmean13).^2).*ydata13)/sum(ydata13);     % 3 klaszter
 
% klaszter sulyfuggvenyek LSE kozelitese Gauss gorbekkel
% optimalis parameterek
xg1 = lsqcurvefit(@(xg1,xdata1) exp(-(xdata1-xg1(1)).^2/2/xg1(2)/xg1(2)), ...
    [xmean11 xstd11], xdata1, ydata11);
% optimalis kozelito Gauss fuggveny
gfv1 = exp(-(xdata1-xg1(1)).^2/2/xg1(2)/xg1(2));
 
xg2 = lsqcurvefit(@(xg2,xdata1) exp(-(xdata1-xg2(1)).^2/2/xg2(2)/xg2(2)), ...
    [xmean12 xstd12], xdata1, ydata12);
gfv2 = exp(-(xdata1-xg2(1)).^2/2/xg2(2)/xg2(2));
 
xg3 = lsqcurvefit(@(xg3,xdata1) exp(-(xdata1-xg3(1)).^2/2/xg3(2)/xg3(2)), ...
    [xmean13 xstd13], xdata1, ydata13);
gfv3 = exp(-(xdata1-xg3(1)).^2/2/xg3(2)/xg3(2));
 
figure(5), subplot(3,1,1), plot(xdata1,ydata11,'og',xdata1,gfv1,'ro'); 
grid; title('1 klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
figure(5), subplot(3,1,2), plot(xdata1,ydata12,'og',xdata1,gfv2,'ro'); 
grid; title('2 klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
figure(5), subplot(3,1,3), plot(xdata1,ydata13,'og',xdata1,gfv3,'ro'); 
grid; title('3 klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
 
% klaszter sulyfuggvenyek LSE kozelitese haromszog gorbekkel
% optimalis parameterek
xr1 = lsqcurvefit(@trianglefmf, [xmean11-xstd11 xmean11 xmean11+xstd11], ...
    xdata1, ydata11);
% optimalis kozelito haromszog fuggveny
tfv1 = trianglefmf(xr1,xdata1);
 
xr2 = lsqcurvefit(@trianglefmf, [xmean12-xstd12 xmean12 xmean12+xstd12], ...
    xdata1, ydata12);
tfv2 = trianglefmf(xr2,xdata1);
 
xr3 = lsqcurvefit(@trianglefmf, [xmean13-xstd13 xmean13 xmean13+xstd13], ...
    xdata1, ydata13);
tfv3 = trianglefmf(xr3,xdata1);
 
figure(7), subplot(3,1,1), plot(xdata1,ydata11,'og',xdata1,tfv1,'ro'); 
grid; title('1 klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
figure(7), subplot(3,1,2), plot(xdata1,ydata12,'og',xdata1,tfv2,'ro'); 
grid; title('2 klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
figure(7), subplot(3,1,3), plot(xdata1,ydata13,'og',xdata1,tfv3,'ro'); 
grid; title('3 klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
 
% klaszter sulyfuggvenyek LSE kozelitese trapez gorbekkel
% optimalis parameterek
xtr1 = lsqcurvefit(@trapezfmf, ...
    [xmean11-2*xstd11 xmean11-xstd11 xmean11+xstd11 xmean11+2*xstd11], xdata1, ydata11);
% optimalis kozelito trapez fuggveny
trfv1 = trapezfmf(xtr1,xdata1);
 
xtr2 = lsqcurvefit(@trapezfmf, ...
    [xmean12-2*xstd12 xmean12-xstd12 xmean12+xstd12 xmean12+2*xstd12], xdata1, ydata12);
trfv2 = trapezfmf(xtr2,xdata1);
 
xtr3 = lsqcurvefit(@trapezfmf, ...
    [xmean13-2*xstd13 xmean13-xstd13 xmean13+xstd13 xmean13+2*xstd13], xdata1, ydata13);
trfv3 = trapezfmf(xtr3,xdata1);
 
figure(8), subplot(3,1,1), plot(xdata1,ydata11,'og',xdata1,trfv1,'ro'); 
grid; title('1 klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');
figure(8), subplot(3,1,2), plot(xdata1,ydata12,'og',xdata1,trfv2,'ro'); 
grid; title('2 klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');
figure(8), subplot(3,1,3), plot(xdata1,ydata13,'og',xdata1,trfv3,'ro'); 
grid; title('3 klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');

% tagsagi fuggvenyek megfelelo rendezese az univerzumok menten
% bemeneti tagsagi fuggvenyek
xu1=[xtr3; xtr2; xtr1;];
xmu1=mean(xu1'); [xmu1,im]=sort(xmu1); xu1sorted=xu1(im,:);
 

