% 2. Feladat: Fuzzy tagsagi fuggvenyek kialaktasa fuzzy klaszterekbol

% a klaszter ponthalmazok kozepertek es variancia adatai 
% LSE parameteres approximaciohoz
xmean21=sum(xdata2.*ydata21)/sum(ydata21);
xstd21=sum(((xdata2-xmean21).^2).*ydata21)/sum(ydata21);     % 1 klaszter
xmean22=sum(xdata2.*ydata22)/sum(ydata22);
xstd22=sum(((xdata2-xmean22).^2).*ydata22)/sum(ydata22);     % 2 klaszter
xmean23=sum(xdata2.*ydata23)/sum(ydata23);
xstd23=sum(((xdata2-xmean23).^2).*ydata23)/sum(ydata23);     % 3 klaszter
 
% klaszter sulyfuggvenyek LSE kozelitese Gauss gorbekkel
% optimalis parameterek
xg1 = lsqcurvefit(@(xg1,xdata2) exp(-(xdata2-xg1(1)).^2/2/xg1(2)/xg1(2)), ...
    [xmean21 xstd21], xdata2, ydata21);
% optimalis kozelito Gauss fuggveny
gfv1 = exp(-(xdata2-xg1(1)).^2/2/xg1(2)/xg1(2));
 
xg2 = lsqcurvefit(@(xg2,xdata2) exp(-(xdata2-xg2(1)).^2/2/xg2(2)/xg2(2)), ...
    [xmean22 xstd22], xdata2, ydata22);
gfv2 = exp(-(xdata2-xg2(1)).^2/2/xg2(2)/xg2(2));
 
xg3 = lsqcurvefit(@(xg3,xdata2) exp(-(xdata2-xg3(1)).^2/2/xg3(2)/xg3(2)), ...
    [xmean23 xstd23], xdata2, ydata23);
gfv3 = exp(-(xdata2-xg3(1)).^2/2/xg3(2)/xg3(2));
 
figure(5), subplot(3,1,1), plot(xdata2,ydata21,'og',xdata2,gfv1,'ro'); 
grid; title('1 klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
figure(5), subplot(3,1,2), plot(xdata2,ydata22,'og',xdata2,gfv2,'ro'); 
grid; title('2 klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
figure(5), subplot(3,1,3), plot(xdata2,ydata23,'og',xdata2,gfv3,'ro'); 
grid; title('3 klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
 
% klaszter sulyfuggvenyek LSE kozelitese haromszog gorbekkel
% optimalis parameterek
xr1 = lsqcurvefit(@trianglefmf, [xmean21-xstd21 xmean21 xmean21+xstd21], ...
    xdata2, ydata21);
% optimalis kozelito haromszog fuggveny
tfv1 = trianglefmf(xr1,xdata2);
 
xr2 = lsqcurvefit(@trianglefmf, [xmean22-xstd22 xmean22 xmean22+xstd22], ...
    xdata2, ydata22);
tfv2 = trianglefmf(xr2,xdata2);
 
xr3 = lsqcurvefit(@trianglefmf, [xmean23-xstd23 xmean23 xmean23+xstd23], ...
    xdata2, ydata23);
tfv3 = trianglefmf(xr3,xdata2);
 
figure(7), subplot(3,1,1), plot(xdata2,ydata21,'og',xdata2,tfv1,'ro'); 
grid; title('1 klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
figure(7), subplot(3,1,2), plot(xdata2,ydata22,'og',xdata2,tfv2,'ro'); 
grid; title('2 klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
figure(7), subplot(3,1,3), plot(xdata2,ydata23,'og',xdata2,tfv3,'ro'); 
grid; title('3 klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
 
% klaszter sulyfuggvenyek LSE kozelitese trapez gorbekkel
% optimalis parameterek
xtr1 = lsqcurvefit(@trapezfmf, ...
    [xmean21-2*xstd21 xmean21-xstd21 xmean21+xstd21 xmean21+2*xstd21], xdata2, ydata21);
% optimalis kozelito trapez fuggveny
trfv1 = trapezfmf(xtr1,xdata2);
 
xtr2 = lsqcurvefit(@trapezfmf, ...
    [xmean22-2*xstd22 xmean22-xstd22 xmean22+xstd22 xmean22+2*xstd22], xdata2, ydata22);
trfv2 = trapezfmf(xtr2,xdata2);
 
xtr3 = lsqcurvefit(@trapezfmf, ...
    [xmean23-2*xstd23 xmean23-xstd23 xmean23+xstd23 xmean23+2*xstd23], xdata2, ydata23);
trfv3 = trapezfmf(xtr3,xdata2);
 
figure(8), subplot(3,1,1), plot(xdata2,ydata21,'og',xdata2,trfv1,'ro'); 
grid; title('1 klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');
figure(8), subplot(3,1,2), plot(xdata2,ydata22,'og',xdata2,trfv2,'ro'); 
grid; title('1 klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');
figure(8), subplot(3,1,3), plot(xdata2,ydata23,'og',xdata2,trfv3,'ro'); 
grid; title('1 klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');

% tagsagi fuggvenyek megfelelo rendezese az univerzumok menten
% bemeneti tagsagi fuggvenyek
xu2=[xtr3; xtr2; xtr1;];
xmu2=mean(xu2'); [xmu2,im]=sort(xmu2); xu2sorted=xu2(im,:);
 
