% 2. Feladat: Fuzzy tagsagi fuggvenyek kialaktasa fuzzy klaszterekbol

% a kimeneti klaszter ponthalmazok kozepertek es variancia 
% adatai LSE parameteres approximaciohoz
xmean1y=sum(xdatay.*ydata1y)/sum(ydata1y);
xstd1y=sum(((xdatay-xmean1y).^2).*ydata1y)/sum(ydata1y); xstd1y=sqrt(xstd1y);
xmean2y=sum(xdatay.*ydata2y)/sum(ydata2y);
xstd2y=sum(((xdatay-xmean2y).^2).*ydata2y)/sum(ydata2y); xstd2y=sqrt(xstd2y);
xmean3y=sum(xdatay.*ydata3y)/sum(ydata3y);
xstd3y=sum(((xdatay-xmean3y).^2).*ydata3y)/sum(ydata3y); xstd3y=sqrt(xstd3y);
xmean4y=sum(xdatay.*ydata4y)/sum(ydata4y);
xstd4y=sum(((xdatay-xmean4y).^2).*ydata4y)/sum(ydata4y); xstd4y=sqrt(xstd4y);
 
% klaszter sulyfuggvenyek LSE kozelitese Gauss gorbekkel
% optimalis parameterek
xg1y = lsqcurvefit(@(xg1y,xdatay) exp(-(xdatay-xg1y(1)).^2/2/xg1y(2)/xg1y(2)), ...
    [xmean1y xstd1y], xdatay, ydata1y);
% optimalis kozelito Gauss fuggveny
gfv1y = exp(-(xdatay-xg1y(1)).^2/2/xg1y(2)/xg1y(2));
 
xg2y = lsqcurvefit(@(xg2y,xdatay) exp(-(xdatay-xg2y(1)).^2/2/xg2y(2)/xg2y(2)), ...
    [xmean2y xstd2y], xdatay, ydata2y);
gfv2y = exp(-(xdatay-xg2y(1)).^2/2/xg2y(2)/xg2y(2));
 
xg3y = lsqcurvefit(@(xg3y,xdatay) exp(-(xdatay-xg3y(1)).^2/2/xg3y(2)/xg3y(2)), ...
    [xmean3y xstd3y], xdatay, ydata3y);
gfv3y = exp(-(xdatay-xg3y(1)).^2/2/xg3y(2)/xg3y(2));

xg4y = lsqcurvefit(@(xg4y,xdatay) exp(-(xdatay-xg4y(1)).^2/2/xg4y(2)/xg4y(2)), ...
    [xmean4y xstd4y], xdatay, ydata4y);
gfv4y = exp(-(xdatay-xg4y(1)).^2/2/xg4y(2)/xg4y(2));

figure(12), subplot(4,1,1), plot(xdatay,ydata1y,'og',xdatay,gfv1y,'ro'); 
grid; title('1 kimeneti klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
figure(12), subplot(4,1,2), plot(xdatay,ydata2y,'og',xdatay,gfv2y,'ro'); 
grid; title('2 kimeneti klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
figure(12), subplot(4,1,3), plot(xdatay,ydata3y,'og',xdatay,gfv3y,'ro'); 
grid; title('3 kimeneti klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
figure(12), subplot(4,1,4), plot(xdatay,ydata4y,'og',xdatay,gfv4y,'ro'); 
grid; title('4 kimeneti klaszter sulyfuggvenye es optimalis Gauss kozelitese'); 
xlabel('osszes adaterjedelem');
 
% klaszter sulyfuggvenyek LSE kozelitese haromszog gorbekkel
% optimalis parameterek
xr1y = lsqcurvefit(@trianglefmf, ...
    [xmean1y-xstd1y xmean1y xmean1y+xstd1y], xdatay, ydata1y);
% optimalis kozelito haromszog fuggveny
tfv1y = trianglefmf(xr1y,xdatay);
 
xr2y = lsqcurvefit(@trianglefmf, ...
    [xmean2y-xstd2y xmean2y xmean2y+xstd2y], xdatay, ydata2y);
tfv2y = trianglefmf(xr2y,xdatay);
 
xr3y = lsqcurvefit(@trianglefmf, ...
    [xmean3y-xstd3y xmean3y xmean3y+xstd3y], xdatay, ydata3y);
tfv3y = trianglefmf(xr3y,xdatay);

xr4y = lsqcurvefit(@trianglefmf, ...
    [xmean4y-xstd4y xmean4y xmean4y+xstd4y], xdatay, ydata4y);
tfv4y = trianglefmf(xr4y,xdatay);

figure(14), subplot(4,1,1), plot(xdatay,ydata1y,'og',xdatay,tfv1y,'ro'); grid;
title('1 kimeneti klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
figure(14), subplot(4,1,2), plot(xdatay,ydata2y,'og',xdatay,tfv2y,'ro'); grid;
title('2 kimeneti klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
figure(14), subplot(4,1,3), plot(xdatay,ydata3y,'og',xdatay,tfv3y,'ro'); grid;
title('3 kimeneti klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
figure(14), subplot(4,1,4), plot(xdatay,ydata4y,'og',xdatay,tfv4y,'ro'); grid;
title('4 kimeneti klaszter sulyfuggvenye es optimalis haromszog kozelitese'); 
xlabel('osszes adaterjedelem');
 
% klaszter sulyfuggvenyek LSE kozelitese trapez gorbekkel
% optimalis parameterek
xtr1y = lsqcurvefit(@trapezfmf, ...
    [xmean1y-xstd1y xmean1y-xstd1y/2 xmean1y+xstd1y/2 xmean1y+xstd1y], xdatay, ydata1y);
% optimalis kozelito trapez fuggveny
trfv1y = trapezfmf(xtr1y,xdatay);
 
xtr2y = lsqcurvefit(@trapezfmf, ...
    [xmean2y-xstd2y xmean2y-xstd2y/2 xmean2y+xstd2y/2 xmean2y+xstd2y], xdatay, ydata2y);
trfv2y = trapezfmf(xtr2y,xdatay);
 
xtr3y = lsqcurvefit(@trapezfmf, ...
    [xmean3y-xstd3y xmean3y-xstd3y/2 xmean3y+xstd3y/2 xmean3y+xstd3y], xdatay, ydata3y);
trfv3y = trapezfmf(xtr3y,xdatay);

xtr4y = lsqcurvefit(@trapezfmf, ...
    [xmean4y-xstd4y xmean4y-xstd4y/2 xmean4y+xstd4y/2 xmean4y+xstd4y], xdatay, ydata4y);
trfv4y = trapezfmf(xtr4y,xdatay);

figure(15), subplot(4,1,1), plot(xdatay,ydata1y,'og',xdatay,trfv1y,'ro'); grid;
title('1 kimeneti klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');
figure(15), subplot(4,1,2), plot(xdatay,ydata2y,'og',xdatay,trfv2y,'ro'); grid;
title('2 kimeneti klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');
figure(15), subplot(4,1,3), plot(xdatay,ydata3y,'og',xdatay,trfv3y,'ro'); grid;
title('3 kimeneti klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');
figure(15), subplot(4,1,4), plot(xdatay,ydata4y,'og',xdatay,trfv4y,'ro'); grid;
title('4 kimeneti klaszter sulyfuggvenye es optimalis trapez kozelitese'); 
xlabel('osszes adaterjedelem');

% kimeneti tagsagi fuggvenyek
xu1y=[xtr4y; xtr3y; xtr2y; xtr1y;];
xmu1y=mean(xu1y'); [xmu1y,imy]=sort(xmu1y); xu1ysorted=xu1y(imy,:);
 

