% 3. Feladat: Fuzzy szabalyok tanulasa mert adatokbol WM modszerrel (szimulalt adatok)

% fuzzy szabalyok tanulasa mert adatok alapjan, irodalom:  
%  The WM Method Completed A Flexible Fuzzy System Approach to Data Mining.pdf
 
load birlabdata;
N = 500;   % adatpontok szama
%data1 = datav(1,:)';
%data2 = datav(2,:)';
%datay = datav(3,:)';

save DataTrain.txt datav -ascii;
 
% a szukseges adatok es leirok beolvasasa
load DataTrain.txt;             % bemeneti adatok: x1(t), x2(t), x3(t), y(t)
load NumFuzSet.txt;             % fuzzy halmazok szama univerzumonkent
load FuzSetData.txt;            % fuzzy halmazok parameterei univerzumokhoz
 
extra=DataTrain';                % bemeneti adatok: x1(t), x2(t), x3(t), y(t)
fnCounts=NumFuzSet;             % fuzzy halmazok szama univerzumonkent
fmfsets=FuzSetData;             % fuzzy halmazok parameterei univerzumokhoz
[NSamples,m]=size(extra); 
NInput=m-1; 
 
% Tagsagi fuggvenyek a bemeneti univerzumok Descartes szorzata felett cellakat
% definialnak (jelen esetben 29 cella van)
% Minden adatszelet [x1(t) x2(t) x3(t)] valamelyik bemeneti cellahoz tartozik, 
% azaz a cellat definialo tagsagi fuggvenyek az egyes x(t) ertekekre legnagyobb 
% ertekeket adnak
actGradesIn=zeros(NSamples,NInput);     % egy szelethez tartozo bemeneti tagsagi 
                                        % fuggveny ertekek: a1, a2, a3
actGradesOut=zeros(NSamples,1);         % egy szelethez tartozo kimeneti tagsagi 
                                        % fuggveny ertek: b
actFnIn=zeros(NSamples,NInput);         % egy szelethez tartozo bemeneti tagsagi 
                                        % fuggveny indexek: tf1, tf2, tf3
actFnOut=zeros(NSamples,1);             % egy szelethez tartozo kimeneti tagsagi
                                        % fuggveny index: tfy
actRulesTmp=zeros(NSamples,NInput+3);   % ideiglenes szabalyrendszerleiro
                                        % [tf1 tf2 a tfy b]
 
% ideiglenes szabalyrendszer szamitasa: egy szabaly bemeneti
% idoszeletenkent
for k=1:NSamples                        % idoszeletek
  for i=1:NInput                        % bemenetek
    NFns=fnCounts(i); gradeV=zeros(1,NFns);
    for nthFn=1:NFns,                   % adott univerzum tagsagi fuggvenyei szerint
        grade=mebextfms(NFns,i,nthFn,extra(k,i),fmfsets);   % tagsagi fv erteke
        gradeV(nthFn)=grade;            % eltarolva
    end;        
    [gradeMax,indexMax]=max(gradeV);    % melyiknel erjuk el a maximumot?
    actGradesIn(k,i)=gradeMax; actFnIn(k,i)=indexMax; % taroljuk el
  end;
                                        % es most u.a. a kimeneti adatra
  NFnsy=fnCounts(m); NFns=fnCounts(m-1); gradeV=zeros(1,NFns);
  for nthFn=1:NFnsy,                    % adott univerzum tagsagi fuggvenyei szerint
      grade=mebextfms(NFns,m,nthFn,extra(k,m),fmfsets);   % tagsagi fv erteke
      gradeV(nthFn)=grade;              % eltarolva 
  end;        
  [gradeMax,indexMax]=max(gradeV);      % melyiknel erjuk el a maximumot?
                                        % ideiglenes leirok elokeszitese
  actGradesOut(k)=gradeMax; actFnOut(k)=indexMax;
  actRulesTmp(k,:)=[actFnIn(k,:), max(actGradesIn(k,:)), actFnOut(k), actGradesOut(k)];
end; 
 
actRules=[];    % a vegleges szabalyleiro: [X1 X2 Y] (X1 AND X2 THEN Y szabalyhoz)
                % redundanciamentes modon (minden szabaly csak egyszer)
 
for i1=1:fnCounts(1), i1, 
    for i2=1:fnCounts(2), i2,   % ciklusok bemeneti univerzumonkent
                                    % az ott definialt tagsagi fuggvenyek
                                    % szerint
            Nifindex=zeros(1,NSamples); % hol fordul elo actulResTmp-ben 
                                        % az adott i1, i2, i3 bemeneti kombinacio
            for k=1:NSamples, 
              cc=(actRulesTmp(k,[1:2])==[i1 i2]); if cc(1)&cc(2), Nifindex(k)=1; end; 
            end;
            Ni=find(Nifindex==1);
            if isempty(Ni), 
            else   % a szabalyleirobol csak az adott bemeneti kombinaciohoz tartozo szabalyokat
                   % valasztjuk ki
                actRulesTmp2=actRulesTmp(Ni,:); NLi=length(Ni);
                
                Nifindex1=[]; 
                for k=1:NLi, % ezekre a szabalyokra megnezzuk, hogy melyiknek eredmenye 
                            % az 1. kimeneti tagsagi fuggveny
                    cc=(actRulesTmp2(k,4)==1); if cc, Nifindex1=[Nifindex1 k]; end; % gyujtsuk ki
                end;
                actRulesTmpY1=actRulesTmp2(Nifindex1,:); % taroljuk el
                NLiY1=length(Nifindex1);    % hany ilyen szabaly van?
                MaxGrRY1=max(actRulesTmpY1(:,3)); % mi a max. bemeneti cella sulya
                MaxGrOutY1=max(actRulesTmpY1(:,5)); % mi a max. kimeneti tf ertek?
                
                Nifindex2=[]; 
                for k=1:NLi, cc=(actRulesTmp2(k,4)==2); if cc, Nifindex2=[Nifindex2 k]; end;  % gyujtsuk ki
                end;
                actRulesTmpY2=actRulesTmp2(Nifindex2,:); NLiY2=length(Nifindex2);
                MaxGrRY2=max(actRulesTmpY2(:,3)); MaxGrOutY2=max(actRulesTmpY2(:,5)); 
                
                Nifindex3=[]; 
                for k=1:NLi, cc=(actRulesTmp2(k,4)==3); if cc, Nifindex3=[Nifindex3 k]; end;  % gyujtsuk ki
                end;
                actRulesTmpY3=actRulesTmp2(Nifindex3,:); NLiY3=length(Nifindex3);
                MaxGrRY3=max(actRulesTmpY3(:,3)); MaxGrOutY3=max(actRulesTmpY3(:,5)); 

                Nifindex4=[]; 
                for k=1:NLi, cc=(actRulesTmp2(k,4)==4); if cc, Nifindex4=[Nifindex4 k]; end;  % gyujtsuk ki
                end;
                actRulesTmpY4=actRulesTmp2(Nifindex4,:); NLiY4=length(Nifindex4);
                MaxGrRY4=max(actRulesTmpY4(:,3)); MaxGrOutY4=max(actRulesTmpY4(:,5)); 

                % most dontsuk el, hogy a szabalyt 1., vagy ... 4. kimeneti
                % tagsagi fuggvennyel zarjuk
                [Ymax, Ypos]=max([MaxGrRY1*NLiY1, MaxGrRY2*NLiY2, MaxGrRY3*NLiY3, MaxGrRY4*NLiY4]);
                Yi=Ypos; 
                actRules=[actRules; [i1 i2 Yi]]; % a vegleges megtanult szabalyleiro
            end; % k
    end; % i2
end; % i1
                
save actRules.txt actRules -ascii;  % a vegleges megtanult szabalyleiro


