% 4. Feladat: A megtanult szabalyok verifikalasa (szimulalt adatok)

% a tanult fuzzy szabalyok verifikalasa kulon teszt adatok alapjan
 
load birlabtest;
N = 500;   % adatpontok szama
save DataTest.txt datav -ascii;

load DataTest.txt;        % tesztadatok a megszokott formatumban
load actRules.txt;        % legeneralt fuzzy szabalyok
load NumFuzSet.txt;       % fuzzy halmazok szama univerzumonkent
load FuzSetData.txt;      % fuzzy halmazok tagsagi fuggvenyei
 
%----------------------------------------
exapp=DataTest';                 
[NSamples,m]=size(exapp); 
NInput=m-1; 
actGrades=zeros(NSamples,4);    % az elsutott fuzzy szabalyok sulya
fmfsets=FuzSetData; 
NR=length(actRules);
yp=zeros(NSamples,1);           % josolt kimeneti ertekek 
 
yt=exapp(:,m);                  % teszt kimeneti ertekek
 
Ff1=fmfsets(NInput*NFns+1,:); Ff2=fmfsets(NInput*NFns+2,:);
Ff3=fmfsets(NInput*NFns+3,:); Ff4=fmfsets(NInput*NFns+4,:);
                                % a 4 kimeneti tagsagi fuggveny leiro
y=[min(exapp(:,3)):.1:max(exapp(:,3))]; % a kimeneti adatok terjedelme
mf1=trapmf(y,Ff1); mf2=trapmf(y,Ff2);   % a kimeneteti trapez 
mf3=trapmf(y,Ff3); mf4=trapmf(y,Ff4);   % tagsagi fuggvenyek generalasa
 
for k=1:NSamples            % idoszeletenkent
  for ir=1:NR, FSi=actRules(ir,:); 
      gradeV=zeros(1,NInput);  % szabalyonkent                                                          % fuzzy
      % a fuzzy rendszer mindig minden szabalyt ertekel ki lepesenkent
   for i=1:NInput,
    x=exapp(k,i);           % egy bemenethez tartozo adat
    NFns=fnCounts(i); grade=mebextfms(NFns,i,FSi(i),x,fmfsets);  % es fuzzy sulya
    gradeV(i)=grade; 
   end;        
   gradeMin=min(gradeV);    % a fuzzy szabaly premissza sulya (minmax kovetkeztetes)
   if actGrades(k,FSi(3))<gradeMin, 
       actGrades(k,FSi(3))=gradeMin; % az elsutheto szabalyok kozul a max. sulyu
   end; 
  end;
  if actGrades(k,1)+actGrades(k,2)+actGrades(k,3)+actGrades(k,4)>0, 
                        % ha van nem 0 szintu kimenetei tagsagi fuggveny
      yp(k)=defuzz(y,actGrades(k,1)*mf1+actGrades(k,2)*mf2+actGrades(k,3)*mf3+actGrades(k,4)*mf4,'centroid');
                        % akkor annak defuzzifikalasaval a josolt ertek
  else yp(k)=0;         % alapeseti ertek hiba (szabaly nelkuli cella) esetere
      % igazi megoldas lenne a szabalyrendszzer kiterjesztese minden cellara, 
      % arra az esetre, ha a tanulasnal hasznalt adatok nem minden cellaba 
      % estek bele es igy nem minden cellahoz rendelten sikerult felepiteni 
      % a benne ervenyes fuzzy szabalyt
  end;
end; %k
 
err=yt-yp; % a josolt ertek hibaja 
elsum=sum(abs(err)); 
elav = elsum/NSamples; % atlagos abszolut hiba 
errel=100*abs(err./yp);

errave=abs(err);
for i=5:N-5, errave(i)=mean(abs(err(i-4:i+4))); end;

figure(20), subplot(311), 
plot([1:NSamples],yt,'b*',[1:NSamples],yt,'b',[1:NSamples],yp,'ro',[1:NSamples],yp,'r'); 
grid; title('* igazi, o model altal josolt'); 
subplot(312), plot([1:NSamples],abs(err),'b',[1:NSamples],errave,'r'); grid; title('hiba');
subplot(313), plot(errel); grid; title('relativ hiba');
axis([1 NSamples 0 200]);


